<?php
/**
* @description : 
* @version $Id: RandomAdInserter.php 1.5
* @copyright OpenGlobal
* @license GPL
* @author OpenGlobal - http://www.openglobal.co.uk
*/
if(!defined('_JEXEC')) die('Restricted access');

jimport( 'joomla.event.plugin' );

$GLOBALS['ograi_adsused'] = 0;

class plgContentRandomAdInserter extends JPlugin {
	function isArticle() {
		return JRequest :: getVar('view') == 'article' ? TRUE : FALSE;
	}

	function isSection() {
		return JRequest :: getVar('view') == 'section' ? TRUE : FALSE;
	}

	function isCategory() {
		return JRequest::getVar('view') == 'category' ? TRUE : FALSE;
	}

	function isHome() {
		$menu = & JSite::getMenu();
		return $menu->getActive() == $menu->getDefault() ? TRUE : FALSE;
	}

	function isFrontPage() {
		return JRequest :: getVar('view') == 'frontpage' ? TRUE : FALSE;
	}

	function isBlogView() {
		return JRequest :: getVar('layout') == 'blog' ? TRUE : FALSE;
	}

	function param($name) {
		static $plugin,$pluginParams;
		if (!isset( $plugin )) {
			$plugin =& JPluginHelper::getPlugin('content', 'RandomAdInserter');
			$pluginParams = new JParameter( $plugin->params );
		}
		return $pluginParams->get($name);
	}

	function plgContentRandomAdInserter( &$subject, $params ) {
		parent::__construct( $subject, $params );
	}

	function trimArray($array) {
		if(!is_array($array)||empty($array)) {
			return array();
		}
		foreach ($array as &$item) {
			$item = trim($item);
		}
		return $array;
	}

	function onPrepareContent( &$article, &$params ) {
		$not_show_articles = $this->trimArray(explode(',',$this->param('not_show_articles')));
		$not_show_cats = $this->trimArray(explode(',',$this->param('not_show_categories')));
		if (!(($article->catid && in_array($article->catid,$not_show_cats)) || ($article->id && in_array($article->id,$not_show_articles)))) {
			if ( ($this->isHome() && $this->param('show_in_home'))
			|| ($this->isSection() && $this->isBlogView() && $this->param('show_in_sections') == 1)
			|| ($this->isCategory() && $this->isBlogView() && ($this->param('show_in_categories') == 1))
			|| ($this->isArticle()) && ($this->param('show_in_articles') == 1)) {
				if ($article->text) {
					if ($GLOBALS['ograi_adsused'] < $this->param('max_ads_per_page')) {
						$GLOBALS['ograi_adsused']++;

						$positions = array();
						$lastpos = -1;
						$repchar = (strpos($article->text, "<p") === false) ? "<br" : "<p";

						while (strpos($article->text, $repchar, $lastpos+1) !== false) {
							$lastpos = strpos($article->text, $repchar, $lastpos+1);
							$positions[] = $lastpos;
						}

						$article->text = substr_replace($article->text, $this->param('adcode').'<div><a href="http://www.openglobal.co.uk">Powered by OpenGlobal</a></div>', $positions[rand(0, sizeof($positions)-1)], 0);
					}
				}
			}
		}
	}
}
?>
